/*
 * このソースコードは blanco Frameworkによって自動生成されています。
 * Apache Antタスク [BlancoXliffUtilExtractState]のクラス
 */
package blanco.xliff.util.task;

import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Task;

import blanco.xliff.util.task.valueobject.BlancoXliffUtilExtractStateProcessInput;

/**
 * Apache Antタスク [BlancoXliffUtilExtractState]のクラス。
 *
 * [XLIFF対応ツール] 指定の state の trans-unit を抽出します。<br>
 * このクラスでは、Apache Antタスクで一般的に必要なチェックなどのコーディングを肩代わりします。
 * 実際の処理は パッケージ[blanco.xliff.util.task]にBlancoXliffUtilExtractStateBatchProcessクラスを作成して記述してください。<br>
 * <br>
 * Antタスクへの組み込み例<br>
 * <pre>
 * &lt;taskdef name=&quot;blancoxliffutilextractstate&quot; classname=&quot;blanco.xliff.util.task.BlancoXliffUtilExtractStateTask">
 *     &lt;classpath&gt;
 *         &lt;fileset dir=&quot;lib&quot; includes=&quot;*.jar&quot; /&gt;
 *         &lt;fileset dir=&quot;lib.ant&quot; includes=&quot;*.jar&quot; /&gt;
 *     &lt;/classpath&gt;
 * &lt;/taskdef&gt;
 * </pre>
 */
public class BlancoXliffUtilExtractStateTask extends Task {
    /**
     * [XLIFF対応ツール] 指定の state の trans-unit を抽出します。
     */
    protected BlancoXliffUtilExtractStateProcessInput fInput = new BlancoXliffUtilExtractStateProcessInput();

    /**
     * フィールド [targetfile] に値がセットされたかどうか。
     */
    protected boolean fIsFieldTargetfileProcessed = false;

    /**
     * フィールド [xliffdir] に値がセットされたかどうか。
     */
    protected boolean fIsFieldXliffdirProcessed = false;

    /**
     * フィールド [state] に値がセットされたかどうか。
     */
    protected boolean fIsFieldStateProcessed = false;

    /**
     * verboseモードで動作させるかどうか。
     *
     * @param arg verboseモードで動作させるかどうか。
     */
    public void setVerbose(final boolean arg) {
        fInput.setVerbose(arg);
    }

    /**
     * verboseモードで動作させるかどうか。
     *
     * @return verboseモードで動作させるかどうか。
     */
    public boolean getVerbose() {
        return fInput.getVerbose();
    }

    /**
     * Antタスクの[targetfile]アトリビュートのセッターメソッド。
     *
     * 項目番号: 1<br>
     * 出力対象の XLIFF (*.xlf) ファイル<br>
     *
     * @param arg セットしたい値
     */
    public void setTargetfile(final String arg) {
        fInput.setTargetfile(arg);
        fIsFieldTargetfileProcessed = true;
    }

    /**
     * Antタスクの[targetfile]アトリビュートのゲッターメソッド。
     *
     * 項目番号: 1<br>
     * 出力対象の XLIFF (*.xlf) ファイル<br>
     * 必須アトリビュートです。Apache Antタスク上で必ず値が指定されます。<br>
     *
     * @return このフィールドの値
     */
    public String getTargetfile() {
        return fInput.getTargetfile();
    }

    /**
     * Antタスクの[xliffdir]アトリビュートのセッターメソッド。
     *
     * 項目番号: 2<br>
     * 入力対象の XLIFF (*.xlf) ファイルが含まれるディレクトリ。<br>
     *
     * @param arg セットしたい値
     */
    public void setXliffdir(final String arg) {
        fInput.setXliffdir(arg);
        fIsFieldXliffdirProcessed = true;
    }

    /**
     * Antタスクの[xliffdir]アトリビュートのゲッターメソッド。
     *
     * 項目番号: 2<br>
     * 入力対象の XLIFF (*.xlf) ファイルが含まれるディレクトリ。<br>
     * 必須アトリビュートです。Apache Antタスク上で必ず値が指定されます。<br>
     *
     * @return このフィールドの値
     */
    public String getXliffdir() {
        return fInput.getXliffdir();
    }

    /**
     * Antタスクの[state]アトリビュートのセッターメソッド。
     *
     * 項目番号: 3<br>
     * trans-unit の state 値。<br>
     *
     * @param arg セットしたい値
     */
    public void setState(final String arg) {
        fInput.setState(arg);
        fIsFieldStateProcessed = true;
    }

    /**
     * Antタスクの[state]アトリビュートのゲッターメソッド。
     *
     * 項目番号: 3<br>
     * trans-unit の state 値。<br>
     * 必須アトリビュートです。Apache Antタスク上で必ず値が指定されます。<br>
     *
     * @return このフィールドの値
     */
    public String getState() {
        return fInput.getState();
    }

    /**
     * Antタスクのメイン処理。Apache Antから このメソッドが呼び出されます。
     *
     * @throws BuildException タスクとしての例外が発生した場合。
     */
    @Override
    public final void execute() throws BuildException {
        System.out.println("BlancoXliffUtilExtractStateTask begin.");

        // 項目番号[1]、アトリビュート[targetfile]は必須入力です。入力チェックを行います。
        if (fIsFieldTargetfileProcessed == false) {
            throw new BuildException("必須アトリビュート[targetfile]が設定されていません。処理を中断します。");
        }
        // 項目番号[2]、アトリビュート[xliffdir]は必須入力です。入力チェックを行います。
        if (fIsFieldXliffdirProcessed == false) {
            throw new BuildException("必須アトリビュート[xliffdir]が設定されていません。処理を中断します。");
        }
        // 項目番号[3]、アトリビュート[state]は必須入力です。入力チェックを行います。
        if (fIsFieldStateProcessed == false) {
            throw new BuildException("必須アトリビュート[state]が設定されていません。処理を中断します。");
        }

        if (getVerbose()) {
            System.out.println("- verbose:[true]");
            System.out.println("- targetfile:[" + getTargetfile() + "]");
            System.out.println("- xliffdir:[" + getXliffdir() + "]");
            System.out.println("- state:[" + getState() + "]");
        }

        try {
            // 実際のAntタスクの主処理を実行します。
            // この箇所でコンパイルエラーが発生する場合、BlancoXliffUtilExtractStateProcessインタフェースを実装して blanco.xliff.util.taskパッケージに BlancoXliffUtilExtractStateProcessImplクラスを作成することにより解決できる場合があります。
            final BlancoXliffUtilExtractStateProcess proc = new BlancoXliffUtilExtractStateProcessImpl();
            if (proc.execute(fInput) != BlancoXliffUtilExtractStateBatchProcess.END_SUCCESS) {
                throw new BuildException("タスクは異常終了しました。");
            }
        } catch (IllegalArgumentException e) {
            if (getVerbose()) {
                e.printStackTrace();
            }
            throw new BuildException(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            throw new BuildException("タスクを処理中に例外が発生しました。処理を中断します。" + e.toString());
        } catch (Error e) {
            e.printStackTrace();
            throw new BuildException("タスクを処理中にエラーが発生しました。処理を中断します。" + e.toString());
        }
    }
}
